unit Register1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Spin, jpeg, AVLockGold, Grids;

type
  TForm1 = class(TForm)
    Image1: TImage;
    AVLock1: TAVLockGold;
    GroupBox2: TGroupBox;
    Pan2: TPanel;
    Label1: TLabel;
    EdName: TEdit;
    PanAction: TPanel;
    Label16: TLabel;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    Lstat: TLabel;
    Pan3: TPanel;
    Label2: TLabel;
    BtnVerify: TButton;
    Pan1: TPanel;
    ChkUserName: TCheckBox;
    PanIns: TPanel;
    Label3: TLabel;
    EdIns: TEdit;
    Memo2: TMemo;
    OpenDialog1: TOpenDialog;
    Memo3: TMemo;
    BtnLoad: TButton;
    SaveDialog1: TSaveDialog;
    BtnSave: TButton;
    BtnReg: TButton;
    procedure FormCreate(Sender: TObject);
    procedure EdAppCodeKeyPress(Sender: TObject; var Key: Char);
    procedure EdCodInsKeyPress(Sender: TObject; var Key: Char);
    procedure BtnVerifyClick(Sender: TObject);
    procedure EdNameKeyPress(Sender: TObject; var Key: Char);
    procedure EdNameChange(Sender: TObject);
    procedure BtnRegClick(Sender: TObject);
    procedure ChkUserNameClick(Sender: TObject);
    procedure BtnLoadClick(Sender: TObject);
    procedure BtnSaveClick(Sender: TObject);
    procedure Memo2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function calculate(n:integer;key:string):integer;
    procedure regstat;
    procedure Fit;
  end;

var
  Form1: TForm1;
  dat,day,users,modul:word;
  codsrc:TInstalCodeSources;

implementation

{$R *.DFM}

function TForm1.calculate(n:integer;key:string):integer;
var ndsk:dword;
    i  :integer;
    act:string;
begin
  //AVLock1.read;
  if (n>0) then begin
    memo3.lines.Add('('+inttostr(n)+')------------------------------------------------');
    memo3.lines.Add('   Key    : '+key);
  end;
  with AVLock1 do
  if UserName in InstalCodeSources
  then begin
    UserCode:=CalcUserCode(EdName.Text);
    Ndsk:=getICode;
    instalCode:=inttohex(Ndsk,6);
  end else instalCode:=EdIns.text;

  result:=AVLock1.decode(key,dat,day,users,modul);
  if (result<>0) then begin
    if (n>0) then
    case result of
    1: memo3.lines.Add('   Registration Key length mismatch');
    2: memo3.lines.Add('   User name missmatch or Invalid Registration Key');
    3: memo3.lines.Add('   Invalid Registration Key');
    else memo3.lines.Add('   Unknown error in Registration Key');
    end;
    exit;
  end;
  act:='';
  if (users=0) then begin
    act:='Unregister all';
    //PanPeriod.Hide;
    //PanUsrs.hide;
  end else begin
    //PanUsrs.show;
    if (dat=maxword) then begin
      act:='Permanent registration for ';
      //PanPeriod.hide;
    end else begin
      act:='Temporary registration for ';
      //PanPeriod.Show;
    end;
  end;
  if (users<>0) then
  if (modul=0) then act:=act+'main application'
  else act:=act+'module '+inttostr(modul);
  if (n>0) then memo3.lines.Add('   Action : '+act);
  //LAction.Caption :=act;
  if (n>0) and (dat<maxword) and (users<>0) then begin
    memo3.lines.Add('   Period : '+inttostr(day)+' days from '+datetostr(dat)+
    ' to '+datetostr(dat+day));
    //memo3.lines.Add('   End date  : '+datetostr(dat+day));
    //memo3.lines.Add('   Days      : '+inttostr(day));
    memo3.lines.Add('   Users  : '+inttostr(users));
  end;
  {
  LBegDate.caption:=datetostr(dat);
  LEndDate.caption:=datetostr(dat+day);
  LDays.caption:=inttostr(day);
  LUsers.caption:=inttostr(users);
  }
end;

procedure TForm1.Fit;
begin
  if ChkUserName.checked then begin
    AVlock1.InstalCodeSources:=[Username];
    EdName.Enabled := True;
    PanIns.Height := 1;
    Pan2.height := 23;
  end else begin
    AVlock1.InstalCodeSources:=codsrc;
    EdName.Enabled := False;
    PanIns.Height := 23;
    Pan2.height := 1;
  end;
  application.processmessages;
end;

procedure TForm1.regstat;
var s,s1:string;
    i:byte;
    dat,day,usrs:word;
    regist,expir,authoriz:boolean;
begin
  with AVLock1 do begin
    read;
    memo1.Clear;
    if (error=-1) then begin
      LStat.caption:=' ------ Registration data not found ------';
      exit;
    end;
    Lstat.caption:=' Module Users Registration  Begin     End       Days DaysLeft ';
    s:='';
    if (error>=0) then with memo1 do begin
      FmtStr(s,' Main  %3d    ',[users]);
      if registered then s:=s+'Permanent                                '
      else if authorized then s:=s+'Temporary     '
      else s:=s+'Trial         ';
      if not registered then begin
        s:=s+formatdatetime('mm/dd/yy  ',begindate)
        +formatdatetime('mm/dd/yy  ',enddate);
        FmtStr(s1,'%4d   ',[days]);
        s:=s+s1;
        if not expired and (enddate>=now) then
        s:=s+inttostr(trunc(enddate-now+1))
        else s:=s+'Expired';
      end;
      memo1.Lines.Add(s);
    end;
    for i:=0 to maxmodules do begin
      error:=0;
      readmodule(i,dat,day,usrs,expir,regist,authoriz);
      if (error=0) then begin
        FmtStr(s,'%4d   %3d    ',[i,usrs]);
        if regist then s:=s+'Permanent                              '
        else s:=s+'Temporary     ';
        if not regist then begin
          s:=s+formatdatetime('mm/dd/yy  ',dat)
          +formatdatetime('mm/dd/yy  ',dat+day);
          FmtStr(s1,'%4d   ',[day]);
          s:=s+s1;
          if expir then  s:=s+'Expired'
          else s:=s+inttostr(trunc(dat+day-now+1));
        end;
        memo1.Lines.Add(s);
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ClientHeight:=Image1.Top+Image1.Height+2;
  ClientWidth:=GroupBox1.Left+GroupBox1.width+10;
  AVLock1.Read;
  EdIns.text:=AVLock1.InstalCode;
  memo2.Font := AVLock1.Font;
  memo3.Font := AVLock1.font;
  memo3.Font.Size := 8;
  {
  Edit1.text:='';
  LAction.caption:='';
  LUsers.caption:='';
  }
  //PanPeriod.Hide;
  codsrc:=AVLock1.InstalCodeSources;//backup copy
  Fit;
  regstat;
end;

procedure TForm1.EdAppCodeKeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in [#8,'0'..'9']) then key:=#0;
end;

procedure TForm1.EdCodInsKeyPress(Sender: TObject; var Key: Char);
begin
  key := upcase(key);
end;

procedure TForm1.BtnVerifyClick(Sender: TObject);
var i:integer;
    s:string;
    ok:boolean;
begin
  ok:=True;
  memo3.Lines.clear;
  for i:=0 to memo2.Lines.Count do begin
    s:=trim(memo2.lines[i]);
    if (length(s)>0) then
    if (calculate(i+1,s)<>0) then ok:=False;
  end;
  if not ok then showmessage('Bad keys found, review it and try again');
  BtnReg.enabled:=ok;
  BtnSave.Enabled:=ok;
end;

procedure TForm1.EdNameKeyPress(Sender: TObject; var Key: Char);
begin
  key:=upcase(key);
end;

procedure TForm1.EdNameChange(Sender: TObject);
begin
  //LAction.caption:='';
  //LUsers.caption:='';
  //PanPeriod.Hide;
  //Btnreg.enabled:=False;
end;

procedure TForm1.BtnRegClick(Sender: TObject);
var i,j:integer;
    RegKey:string;
begin
  j:=0;
  for i:=0 to memo2.Lines.Count do begin
    RegKey:=memo2.lines[i];
    if (calculate(0,RegKey)=0) then begin;
      if (users=0) then begin //unregister
        {
        if (modul = 0) and not (MessageDlg('really want you to delete all registration data?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes) then exit;
        }
        avlock1.EraseReg(modul);
      end else begin;
        if (modul in[0,255]) then avlock1.write(RegKey) //main app
        else avlock1.writemodule(RegKey);  //modules
      end;
      inc(j);
    end;
  end;
  showmessage(inttostr(j)+' Keys registered');
  regstat;
end;

procedure TForm1.ChkUserNameClick(Sender: TObject);
begin
  Fit;
  regstat;
end;

procedure TForm1.BtnLoadClick(Sender: TObject);
begin
  if opendialog1.Execute then begin
    memo2.Clear;
    memo2.Lines.LoadFromFile(opendialog1.filename);
  end;
end;

procedure TForm1.BtnSaveClick(Sender: TObject);
begin
  if savedialog1.Execute then memo3.Lines.SaveToFile(savedialog1.filename);
end;

procedure TForm1.Memo2Change(Sender: TObject);
begin
  Btnreg.Enabled := False;
  Btnsave.Enabled :=False;
end;

end.
